/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/
/* System. */
#include <stdio.h>

/* Our own. */
#include "alphan.h"

char *
frq (char *block)
{

  unsigned int itra = 0, itrb = 0, itrc = 0, itrd = 0;
  unsigned int a26[25], curs = 0, ptr = 0, tmp = 0;
  char *smash;
  char lclatin[] = {
    'a', 'b', 'c', 'd', 'e',
    'f', 'g', 'h', 'i', 'j',
    'k', 'l', 'm', 'n', 'o',
    'p', 'q', 'r', 's', 't',
    'u', 'v', 'w', 'x', 'y',
    'z'
  };
  char fen[] = {
    'e', 't', 'a', 'o', 'i',
    'n', 's', 'r', 'h', 'l',
    'd', 'c', 'u', 'm', 'f',
    'p', 'g', 'w', 'y', 'b',
    'v', 'k', 'x', 'j', 'q',
    'z'
  };

  smash = (char *) calloc (strlen (block), sizeof (char));
  strcpy (smash, block);
  for (itra = 0; itra < strlen (block); itra++)
    {
      if (isupper (block[itra]))
	{
	  smash[itra] = tolower (block[itra]);
	}
      if (islower (block[itra]))
	{
	  smash[itra] = block[itra];
	}
      else
	{
	  smash[itra] = block[itra];
	}
    }
  free (block);
  for (itra = 0; itra < 26; itra++)
    a26[itra] = 0;
  for (itra = 0; itra < strlen (smash); itra++)
    if (isalpha (smash[itra]))
      for (itrb = 0; itrb < strlen (lclatin); itrb++)
	if (smash[itra] == lclatin[itrb])
	  {
	    a26[itrb] += 1;
	    break;
	  }
  for (ptr = 0, itrd = 0; ptr < strlen (smash); ptr++)
    {
      if (isalpha (smash[ptr]))
	{
	  for (itra = 0, tmp = a26[0]; itra < 26; itra++)
	    {
	      if (tmp < a26[itra])
		{
		  tmp = a26[itra];
		  curs = itra;
		}
	    }
	  a26[curs] = 0;
	  if (tmp > 1)
	    {
	      for (itrb = 0; itrb < strlen (smash); itrb++)
		if (smash[itrb] == lclatin[curs])
		  smash[itrb] = fen[itrd];
	      itrd++;
	    }
	}
    }

  return smash;
}

int permute(char *str)
{

	int limit, tmp;
  static int perm=0;
	int used[strlen(str)];
	int itra, cnt, ent=0;
	char *spr, *cmp;
  FILE *fp;
	static int tdone=0;

	spr=(char *) calloc(strlen(str), sizeof(char));
	cmp=(char *) calloc(strlen(str), sizeof(char));

	/* initialize semaphores */

	limit = strlen(str);

	for(itra=0; itra<strlen(str); itra++)
		used[itra]=0;

	/* get number of permutations */

  if(!perm)
  {
	   for(itra=strlen(str), perm=1; itra>0; itra--)
	     perm=perm*itra;
  }

	/* calculate all permutations */

	for(cnt=0;cnt!=strlen(str);srand(time(NULL)))
	{
		tmp=rand()%limit;
		if(!used[tmp]) {
			used[tmp]++;
			spr[cnt]=str[tmp];
			if(cnt<strlen(str))
				cnt++;
		}
		usleep(10);
	}

	/* print and redo */

	if(tdone++<perm)
	{
		if((fp=fopen(DBFILE, "r"))!=NULL)
		{
			while(!feof(fp))
			{
				fscanf(fp, "%s\n", cmp);
				cmp[strlen(spr)]='\0';
				if(!strcmp(spr, cmp)) 
					ent++;
			}
			fclose(fp);
		}
		if(!ent && (fp=fopen(DBFILE, "a"))!=NULL)
		{
			fprintf(fp, "%s\n", spr);
    
      /* display */

      fprintf(stdout, "%s\n", spr);

			fclose(fp);
		}
		if(ent)
			tdone--;

		/* recurre */

		permute(spr);
	}

  unlink(DBFILE);

	return 0;
}

int combine(char *str, int cell)
{

  FILE *fp;
  int used[strlen(str)];
  int itra, cnt, ent=0;
  int limit, tmp;
  int perma, permb, permc;
  static int comb=0;
  char *spr, *cmp;
  static int tdone=0;

  spr = (char *) calloc(cell, sizeof(char));
  cmp = (char *) calloc(cell, sizeof(char));

  /* initialize */

  for(itra=strlen(str); itra>=0; itra--)
    used[itra]=0;

  /* calculate number of valid combinations */

  if(!comb)
  {
    for(itra=strlen(str), perma=1; itra>0; itra--)
      perma=perma*itra;
  
    for(itra=strlen(str)-cell, permb=1; itra>0; itra--)
      permb=permb*itra;

    for(itra=cell, permc=1; itra>0; itra--)
      permc=permc*itra;

    comb=perma/(permb*permc);

    if(comb==1)
      {
        permute(str);
        exit(0);
      }
  }

  limit = strlen(str);

  for(cnt=0; cnt!=cell; srand(time(NULL)))
    {
      tmp = rand()%limit;
      if(!used[tmp]) {
        used[tmp]++;
        spr[cnt]=str[tmp];
        if(cnt<cell)
          cnt++;
      }
      usleep(100);
    }

  if(tdone++<comb)
  {
    if((fp=fopen(DBFILE, "r"))!=NULL)
      {
        while(!feof(fp))
          {
            fscanf(fp, "%s\n", cmp);
            cmp[strlen(spr)]='\0';
            if(!strcmp(spr, cmp))
              ent++;
          }
        fclose(fp);
      }
    if(!ent && (fp=fopen(DBFILE, "a"))!=NULL)
      {
         fprintf(fp, "%s\n", spr);

          /* display */

          fprintf(stdout, "%s\n", spr);

          fclose(fp);
       }
    if(ent)
      tdone--;

    /* recurre */

    combine(str, cell);

  }

  unlink(DBFILE);

  return 0;
}

