/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "alphCRYPT.h"

unsigned char base64_table[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
unsigned char decode_base64_char(unsigned char c);
int is_base64(unsigned char c);

char
*base64(int *org)
{
	char *tmp;
	int *imp;
	int size=0;
	int itra;

	while(org[size++]);

	if(!al_dec)
	{
    imp = (int *) calloc(size, sizeof(int));
      for(itra=0; itra<size; itra++)
        imp[itra]=org[itra];
		tmp = (char *) calloc(3*size, sizeof(char));
		strcpy(tmp, encode_base64(imp));
		return tmp;
	}
	else
	{
		imp=(int *) calloc(size, sizeof(char));
		tmp=(char *) calloc(size, sizeof(char));
		for(itra=0; itra<size; itra++)
			tmp[itra]=(char) org[itra];
		imp=decode_base64(tmp);
		for(itra=0; itra<size; itra++)
			tmp[itra]=(char) imp[itra];
		return tmp;
	}

}

char 
*encode_base64(int *org)
{

	unsigned int c, itra = 0, itrb = 0, itrc = 0, itrd = 0;
	unsigned int pln[3], enc[4];
	unsigned char *dst;

	while(org[itrb++]);

	dst = (char *) calloc(itrb*3, sizeof(char));

	while (c=org[itrc++])
	{
		pln[itra++] = c;
		if (itra == 3)
		{
			enc[0] = (pln[0] & 0xfc) >> 2;
			enc[1] = ((pln[0] & 0x03) << 4) + ((pln[1] & 0xf0) >> 4);
			enc[2] = ((pln[1] & 0x0f) << 2) + ((pln[2] & 0xc0) >> 6);
			enc[3] = pln[2] & 0x3f;

			for(itra = 0; itra < 4; itra++)
				dst[itrd++]=base64_table[enc[itra]];

			itra=0;
		}
	}

	if (itra)
	{
		for(itrb = itra; itrb < 3; itrb++)
			pln[itrb] = '\0';

		enc[0] = (pln[0] & 0xfc) >> 2;
		enc[1] = ((pln[0] & 0x03) << 4) + ((pln[1] & 0xf0) >> 4);
		enc[2] = ((pln[1] & 0x0f) << 2) + ((pln[2] & 0xc0) >> 6);
		enc[3] = pln[2] & 0x3f;

		for (itrb = 0; itrb < itra + 1; itrb++)
			dst[itrd++]=base64_table[enc[itrb]];

		while(itra++ < 3)
			dst[itrd++]='=';
	}

	return dst;
}

int 
*decode_base64(char *org)
{
	unsigned int c, itra = 0, itrb = 0, itrc=0, itrd=0;
	unsigned int enc[4], dec[3];
	unsigned int *dst;

	while(org[itrb++]);

	dst = (int *) calloc(itrb*3, sizeof(int));

	while ((c = org[itrc++]) && c != '=' && (is_base64(c) || isspace(c)))
	{
		if (isspace(c))
			continue;

		enc[itra++] = c;

		if (itra == 4)
		{
			for (itra = 0; itra < 4; itra++)
				enc[itra] = decode_base64_char(enc[itra]);

			dec[0] = (enc[0] << 2) + ((enc[1] & 0x30) >> 4);
			dec[1] = ((enc[1] & 0xf) << 4) + ((enc[2] & 0x3c) >> 2);
			dec[2] = ((enc[2] & 0x3) << 6) + enc[3];

			for (itra = 0; itra < 3; itra++)
				dst[itrd++]=dec[itra];

			itra = 0;
		}
	}

	if (itra)
	{
		for (itrb = itra; itrb < 4; itrb++)
			enc[itrb] = 0;

		for (itrb = 0; itrb < 4; itrb++)
			enc[itrb] = decode_base64_char(enc[itrb]);

		dec[0] = (enc[0] << 2) + ((enc[1] & 0x30) >> 4);
		dec[1] = ((enc[1] & 0xf) << 4) + ((enc[2] & 0x3c) >> 2);
		dec[2] = ((enc[2] & 0x3) << 6) + enc[3];

		for (itrb = 0; itrb < itra - 1; itrb++)
			dst[itrd++]=dec[itrb];
	}

	return dst;
}



unsigned char 
decode_base64_char(unsigned char c)
{
	unsigned char *p = base64_table, i = 0;

	while(*(p + i) != c)
		i++;

	return i;

}

int 
is_base64(unsigned char c)
{
	if (isalnum(c))
		return 1;

	if (c == '+')
		return 1;

	if (c == '/')
		return 1;

	return 0;
}

